/*****************************************************************************
    client.c

    Diese Datei ist Teil des Programmpakets 'ACL-tftp'.
    Alle Rechte bei Andreas G. Schindler
                    Klappacher Str. 2i
                    64285 Darmstadt, Deutschland.

    Dieses Programm ist 'Freie Software'; Sie knnen es entsprechend den 
    Bedingungen der 'Allgemeinen ffentlichen GNU-Lizenz' (verffentlicht 
    durch die 'Free Software Foundation') weiter verbreiten und/oder 
    modifizieren. Massgeblich ist die Version 2 oder eine neuere Version
    dieser Lizenz. 

    Dieses Programm wird in der Hoffnung dass es ntzlich is weitergegeben,
    jedoch OHNE JEDE GARANTIE. Dieser Garantieauschluss bezieht sich auch
    auf Eigenschaften wie Marktfhigkeit oder Eignung zu einem bestimmten
    Zweck. Details finden sich in der 'Allgemeinen ffentlichen GNU-Lizenz'.

    Eine Kopie dieser Lizenz sollte in  Programmpaket, dem diese Datei
    entstammt, enthalten sein. Falls nicht, schreiben Sie an die 
    'Free Software Foundation, Inc.', 59 Temple Place, Suite 330, Boston, 
    MA  02111-1307  USA.


    This file is part of the 'ACL-tftp' Package
    Copyright (C) 1999-2005 by Andreas G. Schindler
                               Klappacher Str. 2i
                               Darmstadt, Germany.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*****************************************************************************/
#define BTFTP
#include "auto.h"
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <sys/signal.h>
#include <sys/time.h>
#include <sys/timeb.h>
#include <sys/param.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdarg.h>

#include <netinet/in.h>
#include <arpa/inet.h>

#include <netdb.h>
#include <stdio.h>
#include <errno.h>
#include <ctype.h>
#include <string.h>
#include <math.h>

#include "client.h"
#include "fileio.h"
#include "logfun.h"
#include "getarg.h"
#include "util.h"
#include "dump.h"
#include "neterror.h"
#include "states.h"

#ifdef MAX
#undef MAX
#endif
#define MAX(A, B)	(((A) >= (B)) ? (A) : (B))

#define isInit		(request->curBlock == 0)
#define isOpt		(request->option.types)
#define isInitOpt	((isInit)&&(isOpt))


static int CsendFile (tftpR_t *request);
static int CsendFile2(tftpR_t *request,tftpD_t *sendBuffer,tftpD_t *initBuffer);
static int CrecvFile (tftpR_t *request);
static int CrecvFile2(tftpR_t *request,tftpD_t *recvBuffer,tftpD_t *initBuffer);

#ifdef DEV_ADDON
static int tftp_client_interact = 0;
static struct timeval dataDelay = {0,0}, ackDelay = {0,0}, noDelay = {0,0};
#endif /* DEV_ADDON */
            
static void Cusage(void)
{
#ifdef DEV_ADDON
    fprintf (stderr, _("Usage is: btftp -h host -f file [ -F file ] [-p port] "
                       "[-l addr] [-r [block_list]|-w] [-b|-a] [-t time] "
                       "[-B size] [-S] [-T time] [-M] "
                       "[-I] -[d delay ] "
                       "[-v] [-P]\n"
                       "    -h host  hostname or IP address of tftp server\n"
                       "    -f file  file name to send/receive\n"
                       "    -F file  transmitted file name\n"
                       "    -p port  port number of tftp server\n"
                       "    -l addr  local address/hostname\n"
                       "    -r list  read/receive file (only blocks <list>)\n"
                       "    -w       write/transmit file\n"
                       "    -b       octet (binary) mode\n"
                       "    -a       net-ascii (text) mode\n"
                       "    -t time  timeout for transfer operations\n"
                       "    -B size  blocksize requested by option\n"
                       "    -2 size  blocksize (power of 2) requested by option\n"
                       "    -S       Total size requested by option\n"
                       "    -T time  timeout requested by option\n"
                       "    -M       requested options are mandatory\n"
                       "    -I       interactive debugging mode\n"
                       "    -d delay Delay sending packets (def: no delay)\n"
                       "             Format: Data: d:<sec>, Ack a:<sec>\n"
                       "    -v       verbose messages\n"
                       "    -P       enable logging prefix (time,PID,etc.)\n\n"
                     ));
#else /* DEV_ADDON */    
    fprintf (stderr, _("Usage is: btftp -h host -f file [ -F file ] [-p port] "
                       "[-l addr] [-r [block_list]|-w] [-b|-a] [-t time] "
                       "[-B size] [-S] [-T time] [-M] "
                       "    -h host  hostname or IP address of tftp server\n"
                       "    -f file  file name to send/receive\n"
                       "    -F file  transmitted file name\n"
                       "    -p port  port number of tftp server\n"
                       "    -l addr  local address/hostname\n"
                       "    -r list  read/receive file (only blocks <list>)\n"
                       "    -w       write/transmit file\n"
                       "    -b       octet (binary) mode\n"
                       "    -a       net-ascii (text) mode\n"
                       "    -t time  timeout for transfer operations\n"
                       "    -B size  blocksize requested by option\n"
                       "    -2 size  blocksize (power of 2) requested by option\n"
                       "    -S       Total size requested by option\n"
                       "    -T time  timeout requested by option\n"
                       "    -M       requested options are mandatory\n"
                       "    -v       verbose messages\n"
                       "    -P       enable logging prefix (time,PID,etc.)\n\n"
                     ));
#endif /* DEV_ADDON */    
} 


#ifdef DEV_ADDON
static void setInteract(int on)
{
    tftp_client_interact = on ? 1 : 0;
    return;
}

#if	0
static int getInteract(void)
{
    return tftp_client_interact;
}
#endif

static int setDelay(char *arg)
{
    int k;
    static char *tokList[] = { "d","a" };
    static char *sep = ":=";
    char *ctx, *tok, *val;

    if ((arg == NULL) || (strlen(arg) == 0))
        return 0;

    tok = xstrtok(arg,  sep, &ctx);
    val = xstrtok(NULL, sep, &ctx);

    if ((tok == NULL) || (val == NULL))
        return -1;

    for (k=((sizeof(tokList)/sizeof(tokList[0]))-1); k>=0; k--) {
        if (!strncasecmp(tok, tokList[k],2))
            break;
    }

    if (k < 0)
        return -2;
       
    switch (k) {
      case 0:
        if (asc2tv(val, &dataDelay))
            return -3;
        break;
      case 1:    
        if (asc2tv(val, &ackDelay))
            return -3;
        break;
    }
    return 1;
}


static struct timeval getDelay(int mode)
{
    if (mode == RT_DATA)
        return dataDelay;
    else if (mode == RT_ACK)
        return ackDelay;

    return noDelay;
}
#endif /* DEV_ADDON */


static int Ccheckargs(tftpR_t *request, char *server, char *port,
                      char *localfile, char *serverfile, 
                      in_addr_t localaddr, int blocksize, int blocksize2,
                      int sendsize, char *ctimeout, char *creqtmo, int mandopt,
                      int getput, int binascii, dlb_t *bl, int verbose)
{
    sopair_t *sp;
    long tmo=0;
    uint bstat;

    globRun(spMode,1);
    globRun(msgLevel,verbose);
    globRun(maxSyslog,0);

    presetRequest (request, RR_CLIENT, NULL);

    if (ctimeout != NULL) {
        if ((sscanf(ctimeout, "%ld", &tmo) != 1) || (tmo <= 0)) {
            if (parseCTimes(ctimeout, &defTimer) < 0) {
                if (verbose)
                    fprintf (stderr, _("Illegal timeout value '%s'"), ctimeout);
                return 1;
            }
        }
        else {
            defTimer.idle = defTimer.conn = 
            defTimer.sack = defTimer.recv = int2tv(tmo, 0);
            if (verbose)
                fprintf (stderr, _("Local timeout: %.1fs"), 
                         tv2double(&defTimer.conn));
        }
    }    

    if (creqtmo != NULL) {
        if ((sscanf(creqtmo, "%ld", &tmo) != 1) || (tmo <= 0)) {
            int rtc;
            rtc = parseCTimes(creqtmo, &defTimer);
            if (rtc < 0) {
                if (verbose)
                    fprintf (stderr, _("Illegal option timeout value '%s'"),
                             creqtmo);
                return 1;
            }
            else if (rtc > 0) {
                request->option.timeout   = defTimer.recv;
                request->option.types    |= ROT_TMO;
            }
        }
        else {
            defTimer.idle = defTimer.conn = 
            defTimer.sack = defTimer.recv = 
            request->option.timeout       = int2tv(tmo, 0);
            request->option.types        |= ROT_TMO;
            if (verbose)
                fprintf (stderr, _("Request timeout: %.1fs"), 
                         tv2double(&defTimer.conn));
        }    
    }

    if ((server == NULL) || (localfile == NULL))
        return 1;

    request->realFile = Strdup(localfile);
    request->times    = defTimer;

    (void)initBackoff(&request->times, STRENGTH);


    if (binascii) 
        request->reqMode = RM_NETASCII;
    else
        request->reqMode = RM_OCTET;

    if (getput)
        request->reqType = RT_WRQ;
    else
        request->reqType = RT_RRQ;

    if (request->reqType == RT_RRQ)
        request->reqFd = open(request->realFile, O_WRONLY|O_CREAT|O_TRUNC,
                              0644);
    else
        request->reqFd = open(request->realFile, O_RDONLY, 0644);

    if (request->reqFd < 0) {
        if (verbose)
            fprintf (stderr, _("Cannot open file '%s' for %s: %m\n"),
                     request->realFile, 
                     (request->reqType == RT_RRQ) ? _("read") : _("write"));
        return 1;
    }

    if (serverfile == NULL)
        request->reqFile = Strdup(request->realFile);
    else
        request->reqFile = Strdup(serverfile);

    if (name2sai(server, port, &request->reqPeer))
        return 1;

    if ((sp = netStart(localaddr, 0)) == NULL) 
        return 1;

    request->Rsock   = sp->recv;
    request->Ssock   = sp->send;
    request->xfrstat = request->iostat = 0;
    request->option.mandatory = mandopt;
    request->bList   = (char *)bl;

    if (blocksize && blocksize2) {
        if (verbose)
            fprintf (stderr, _("Options -B and -2 are mutually exclusive\n"));
        return 1;
    }

    if (blocksize) {
        request->option.blocksize = blocksize;
        request->option.types    |= ROT_BSZ;
    }

    if (blocksize2) {
#ifdef BLOCKSIZE_2
        request->option.blocksize = blocksize2;
        request->option.types    |= ROT_BSZ2;
#else
        fprintf (stderr, _("Option 'blksize2' not supported\n"));
        return -1;
#endif /* BLOCKSIZE_2 */
    }

    if (blocksize | blocksize2) {
/*
	let's check if the current block size fits the rec/xmit buffer size
        if not, reduce the block zize apropriately
*/
        bstat = setNetBuffer(request->Rsock, blocksize);
        if ((bstat > 0) &&  (bstat < (uint)blocksize)) {
            request->option.blocksize = bstat;
            LOG_MSG3 (LOG_NOTICE, _("Reducing requested block size to %u"), 
                      bstat);
        }
    }
    else {
        request->option.blocksize = SEGSIZE;
    }

    if (sendsize) {
        if (request->reqType == RT_RRQ)
            request->option.totalsize = 0;
        else {
            struct stat st;
            if (fstat(request->reqFd, &st)) {
                if (verbose)
                    LOG_MSG1 (LOG_ERR, _("Cannot stat file '%s': %m\n"),
                              request->realFile);
                return 1;
            }
            request->option.totalsize = st.st_size;
        }
        request->option.types  |= ROT_TSZ;
    }

    if ((request->bList != NULL) && (msgLevel >= 5)) {
        char *buf;

        if ((buf = dumpbList(bl)) != NULL) {
            LOG_MSG5 (LOG_DEBUG, "Listed Blocks: %s", buf);
            free(buf);
        }
    }

    return 0;
}

int Csetup(tftpR_t *request, int argc, char **argv)
{
    char *server, *port, *laddr, *localfile, *serverfile, *ctimeout, *creqtmo;
    static char *allopts = "h:p:f:F:rwv:abB:St:T:VM:IAR:2:d:";
    int blocksize, blocksize2,sendsize, verbose, 
        binascii=0, getput=0, mandopt=0, interact=0;
    int ma, mb, mr, mw;
    char *cblist; 
#ifdef DEV_ADDON
    char *cdelay;
#endif /* DEV_ADDON */
    dlb_t *bList;

    doLocale   = getarg(argc, argv, allopts, 'A', "", NULL);
    initLocale(doLocale);

    if (getarg (argc, argv, allopts, 'V', "", NULL) != NULL) {
        version(stderr, "client");
        copyright(stderr, 0);
        exit(0);
    }

    port       = getarg(argc, argv, allopts, 'p', "tftp", "tftp");
    laddr      = getarg(argc, argv, allopts, 'l', NULL, NULL);
    server     = getarg(argc, argv, allopts, 'h', NULL, NULL);
    localfile  = getarg(argc, argv, allopts, 'f', NULL, NULL);
    serverfile = getarg(argc, argv, allopts, 'F', NULL, NULL);
    ctimeout   = getarg(argc, argv, allopts, 't', NULL, NULL);
    creqtmo    = getarg(argc, argv, allopts, 'T', NULL, NULL);
    cblist     = getarg(argc, argv, allopts, 'R', NULL, NULL);
#ifdef DEV_ADDON
    cdelay     = getarg(argc, argv, allopts, 'd', NULL, NULL);
#endif /* DEV_ADDON */
    mr         = atoi(getarg(argc, argv, allopts, 'r', "1", "0"));
    mw         = atoi(getarg(argc, argv, allopts, 'w', "1", "0"));
    ma         = atoi(getarg(argc, argv, allopts, 'a', "1", "0"));
    mb         = atoi(getarg(argc, argv, allopts, 'b', "1", "0"));
    blocksize  = atoi(getarg(argc, argv, allopts, 'B', "0", "0"));
    blocksize2 = atoi(getarg(argc, argv, allopts, '2', "0", "0"));
    sendsize   = atoi(getarg(argc, argv, allopts, 'S', "1", "0"));
    mandopt    = atoi(getarg(argc, argv, allopts, 'M', "1", "0"));
    interact   = atoi(getarg(argc, argv, allopts, 'I', "1", "0"));
    verbose    = atoi(getarg(argc, argv, allopts, 'v', "1", "0"));
    
    if ((server == NULL) || (localfile == NULL)) {
        Cusage();
        return 1;
    }

    if (ma && mb) {
        if (verbose)
            fprintf (stderr, _("Ambigous transfer mode\n"));
        return 1;
    }
    else
        binascii = ma;

    if (cblist == NULL) {
        bList = NULL;
    }
    else {
        if (parseCmr(cblist, &bList)) {
            if (verbose)
                fprintf (stderr, _("Illegal transfer block list\n"));
            return 1;
        }
    }

    if (mr && mw) {
        if (verbose)
            fprintf (stderr, _("Ambigous transfer direction\n"));
        return 1;
    }
    else
        getput = mw;

#ifdef DEV_ADDON
    if (setDelay(cdelay) < 0)
        if (verbose)
            fprintf (stderr, _("Illegal delay parameter\n"));

    setInteract(interact);
#endif /* DEV_ADDON */

    return (Ccheckargs(request, server, port, localfile, serverfile,
                       xinet_addr(laddr, 1), blocksize, blocksize2,
                       sendsize, ctimeout, creqtmo, mandopt,
                       getput, binascii, bList, verbose));
}


void CstatusTrace(tftpR_t *request)
{
    char *pfx1, *pfx2;
    char* fmt1 = "Local I/O (Disk) %ld Bytes %s";
    char* fmt2 = "Network I/O %ld Bytes %s in %gs (%g kBytes/s)";

    request->times.stop = uftime(NULL);

    if (request->reqType == RT_RRQ) {
        pfx1 = "written";
        pfx2 = "received";
    }
    else {
        pfx1 = "read";
        pfx2 = "transmitted";
    }

    doLog (LOG_INFO, fmt1, request->iostat, pfx1);
    doLog (LOG_INFO, fmt2, request->xfrstat, pfx2, 
           elapTime(request), xfrRate(request));
    return;
}

static void startMsg (tftpR_t *request)
{
    sai_t mysock;
    socklen_t mysocklen = (socklen_t)sizeof(mysock);
    
    getsockname(request->Rsock,(sa_t *)&mysock, &mysocklen);

    LOG_MSG3 (LOG_NOTICE, _("%stransfer started from %s:%hd for file '%s'"),
	      (request->reqType == RT_RRQ) ? _("Read ") : _("Write "),
	      xinet_ntoa((in_addr_t)mysock.sin_addr.s_addr,
			 doResolv & RES_RUNTIME),
	      ntohs(mysock.sin_port), request->reqFile);
    LOG_MSG3 (LOG_NOTICE, _("Peer at %s:%hd"),
	      xinet_ntoa((in_addr_t)request->reqPeer.sin_addr.s_addr,
			 doResolv & RES_RUNTIME),
	      ntohs(request->reqPeer.sin_port));
    LOG_MSG3 (LOG_NOTICE, _("Message level: %d"), msgLevel);
    LOG_MSG4 (LOG_INFO, _("Timing: %s"), timer2asc(&request->times,T2A_ALL));
    if (request->option.types)
        LOG_MSG4 (LOG_INFO, _("Requested options: %s"), textOptions(request));
    return;
}

/*
	generate an initial request packet
*/

static tftpD_t *mkInitPkt (tftpR_t *request, tftpD_t *ipack, int *ilen)
{
    static char  *modeStrings[4] = { "", RMS_OCTET, RMS_NETASCII, RMS_MAIL };
    char *optbuf, *modstr;
    int optlen, modlen, fillen;
    *ilen = -1;

    if ((optbuf = appendOptions(NULL, request, &optlen)) == NULL) {
        errNoDynmem;
        return NULL;
    }
    if (optlen < 0) {
        Free(optbuf);
        return NULL;
    }

    modstr = modeStrings[request->reqMode];
    modlen = strlen(modstr) + 1;
    fillen = strlen(request->reqFile) + 1;

    if ((optlen+fillen+modlen) > SEGSIZE) {
        Free(optbuf);
	LOG_MSG1 (LOG_ERR, _("File name or options too long"));
        return NULL;
    }

    if (ipack == NULL) {
        if ((ipack = Malloc(sizeof(tftpD_t))) == NULL) {
            errNoDynmem;
            Free(optbuf);
            return NULL;
        }
    }

    ipack->head.opCode = htons((short)request->reqType);
    strcpy (ipack->head.reqText, request->reqFile);
    strcpy (ipack->head.reqText+fillen, modstr);
    if (optlen)
        memcpy (ipack->head.reqText+fillen+modlen, optbuf, optlen);

    Free(optbuf);

    *ilen  = sizeof(ipack->head.opCode)+fillen+modlen+optlen;
    return ipack;
}

/*
	set up a new (active) transfer request
*/

int CdoRequest (tftpR_t *request)
{
    if (request->reqType == RT_RRQ)
        return CrecvFile(request);
    else
        return CsendFile(request);
}

/*
	read request (RRQ): receive a file from the server

	jacket routine to CrecvFile2 (see below)
	this is done to assure an easy cleanup of dyn memory
	at function return
*/

int CrecvFile (tftpR_t *request)
{
    tftpD_t *recvBuffer;	/* receive buffer (one packet)	*/
    tftpD_t *initBuffer = NULL;	/* XFER initialization buffer	*/
    int rtc, bufsize;

    request->times.start = request->times.stop = uftime(NULL);

    bufsize = MAX(request->option.blocksize, SEGSIZE) + sizeof(tftpH_t);

    if ((recvBuffer = (tftpD_t *)Malloc(bufsize)) == NULL) {
        errNoDynmem;
        request->times.stop = uftime(NULL);
        return -1;
    }

    if (initXferBuffer(request->option.blocksize)) {
        sendError(request, PE_NOSPACE, NULL);
        return -1;
    }

    rtc = CrecvFile2 (request, recvBuffer, initBuffer);

    rmXferBuffer();
    request->times.stop = uftime(NULL);
    Free(recvBuffer);
    if (initBuffer != NULL)
        Free(initBuffer);
    return rtc;
}

/*
	transfer processing according to RFC 2347:

      client                                           server
      -------------------------------------------------------
      |1|foofile|0|octet|0|blksize|0|1432|0|  -->         RRQ
                             <--  |6|blksize|0|1432|0|   OACK
      |4|0|  -->                                          ACK
                      <--  |3|1| 1432 octets of data |   DATA
      |4|1|  -->                                          ACK
                      <--  |3|2| 1432 octets of data |   DATA
      |4|2|  -->                                          ACK
                      <--  |3|3|<1432 octets of data |   DATA
      |4|3|  -->                                          ACK

*/

static int CrecvFile2 (tftpR_t *request,tftpD_t *recvBuffer,tftpD_t *initBuffer)
{
    tftpD_t ackBuffer;		/* acknowledge packet		*/
    int recvLength = 0;		/* received bytes		*/
    int initLength;		/* length of init packet	*/
    int hsock;			/* highest socket+1 (select)	*/
    ushort thisBlock = 0;	/* just received data block	*/
    ushort opCode;		/* last packet's op code	*/
    int done = 0;		/* flag for end-of-transfer	*/
    int rtc;			/* general function return code	*/
    fd_set fdSel;		/* select bitmap		*/
    sai_t peer;			/* temp buffer for recvfrom     */
    socklen_t peerLength;	/* length of temp buffer	*/
    struct timeval timeout;	/* select timeout 		*/
#ifdef DEV_ADDON
    struct timeval delay;	/* send/ack delay time		*/
#endif /* DEV_ADDON */
    enum io_states state;	/* state machine status	*/	

    hsock = MAX(request->Rsock, request->Ssock) + 1;

/*
	Loop through the sate-machine that implements the receive algorithm
	Note: request->lastAck holds the last successul received blok number
	      if no block was received at all, lastAck := 0
              request->curBlock holds the block number of the next block
              expected.
*/

    state = ST_INITWAIT;

    for (;;) {

        if (doTrace) {
            doTrace = 0;
            CstatusTrace (request);
        }

	LOG_MSG6 (LOG_DEBUG, "%s: state %d: %s", __FUNCTION__, 
                  state,state_names[state]);

	switch (state) {

            default:
                LOG_MSG1 (LOG_ERR, _("Internal state machine error"));
                break;

/*
	wait for the output channel to become available
	to send the initial request packet.
	we do not allow timeouts at this state
*/
            case ST_INITWAIT:
                FD_ZERO(&fdSel);
                FD_SET(request->Ssock, &fdSel);

                timeout = proBackoff(&request->times, EBS_SEND, request->retry);

                LOG_MSG6 (LOG_DEBUG, "%s: timeout %.1fs", __FUNCTION__,
                          tv2double(&timeout));

                rtc = select (request->Ssock + 1, NULL, &fdSel, NULL, &timeout);

                switch(checkSelError(request, rtc, BM_INIT)) {
                    case PC_ERROR:
                    case PC_RETRY:
                        return -1;
                }
                state = ST_INIT;
                break;

/*
	assemble the initial request packet and send ist over
*/
            case ST_INIT:
                if (initBuffer == NULL)
                    initBuffer = mkInitPkt(request, NULL, &initLength);
                if (initBuffer == NULL)
                    return -1;

                startMsg (request);

                rtc = sendto(request->Ssock, initBuffer, initLength, 0,
	                     (sa_t *)&request->reqPeer, sizeof(sai_t));

                switch(checkSendError(request, rtc, initLength, BM_INIT)) {
                    case PC_ERROR:
                        return -1;
                    case PC_RETRY:
                        state = ST_INITWAIT;
                        continue;
                }
                state = ST_RECVWAIT;
                break;
/*
	wait for data packet - this is actually a 'wait for any reply',
	because we are prepared to receive any packet, especially error packets.

	On timeout, we check the retry-count.
	This counter will be reset on any sucessfully transferred packet.
	If retries are still allowed, we re-ack the latest packet.
*/
	    case ST_RECVWAIT:
		FD_ZERO(&fdSel);
		FD_SET(request->Rsock, &fdSel);

                timeout = proBackoff(&request->times, 
                                     isInit ? EBS_CONN : EBS_RECV, 
                                     request->retry);

                LOG_MSG6 (LOG_DEBUG, "%s: timeout %.1fs", __FUNCTION__,
                          tv2double(&timeout));

		rtc = select (hsock, &fdSel, NULL, NULL, &timeout);

                switch(checkSelError(request,rtc,isInitOpt?BM_DOACK:BM_DATA)) {
                    case PC_ERROR:
                        return -1;
                    case PC_RETRY:
                        state = isInit ? ST_INITWAIT : ST_ACKWAIT_AGAIN;
                    case PC_AGAIN:
                        continue;
                }
		state = ST_RECV;
		break;
/*
	The received packed should be at least of length sizeof(tftpD_t)
	(usually 4 bytes). Short packets are silently discarded:
	we proceed as with timeouts above.

	Now let's check the opcode of the received packets.
	All non-data packets are considered fatal transfer errors, which
	lead to an abort of the current transfer.
*/
	    case ST_RECV:
		peer = request->reqPeer;
		peerLength = sizeof(peer);
		recvLength = recvfrom (request->Rsock, recvBuffer, 
				       request->option.blocksize + 
                                       sizeof(tftpH_t),
                                       MSG_TRUNC, (sa_t *)&peer, &peerLength);

                LOG_MSG6 (LOG_DEBUG, "%s: block %hd, size %d received", 
                          __FUNCTION__, ntohs(recvBuffer->head.blockNo),
                          recvLength); 

                if (isInit)
                    request->reqPeer = peer;

                if (isInitOpt)
                    rtc = checkDataOack(request, recvBuffer, recvLength);
                else
                    rtc = checkData(request, recvBuffer, recvLength);

                switch (rtc) {
                    case PC_ERROR:
			return -1;
                    case PC_RETRY:
		        state = isInit ? ST_INIT : ST_ACKWAIT_AGAIN;
		        break;
		}

                thisBlock = ntohs(recvBuffer->head.blockNo);
                opCode    = ntohs(recvBuffer->head.opCode);

                switch(opCode) {

/*
	this is an option acknowledge
	check for validity and adjust options accordingly
*/
                case RT_OACK:
                    if (!isOpt) {
                        LOG_MSG1 (LOG_ERR, _("OACK without request"));
                        sendError(request, PE_BADOP,"OACK without request");
		        if (retryPossible(request,-1,NULL) == PC_ERROR)
                            return -1;
		        state = ST_INIT;
                        break;
                    }
		    if (thisBlock) {
                        logSequenceError("OACK", thisBlock, 0);
                        sendError(request, PE_BADOP, "OACK out of sequence");
		        if (retryPossible(request, -1, NULL) == PC_ERROR)
                            return -1;
		        state = ST_INIT;
                        break;
                    }
                    if (checkOptions(recvBuffer->data,
                                     recvLength - sizeof(tftpH_t), request)) {
                        LOG_MSG1 (LOG_ERR, _("Bad OACK options"));
                        sendError(request, PE_BADOP, "Bad OACK options");
		        if (retryPossible(request, -1, NULL) == PC_ERROR)
                            return -1;
		        state = ST_INIT;
                        break;
                    }

                    state = ST_ACKWAIT;
                    break;
/*
	We got a data packet, so lets check the block number.
	Only 1 case is valid: current-block. If this is the first data
	packet to arrive (lastAck == 0), we preset currBlock to 1.
	This is necessary to provide for the following case:
	With options enabled, the first packet to arrive may be an OACK
	or a DATA packet (options discarded by the server). In the first
	case the ACK section will advance curBlock automatically, in the
	latter not, thus the preset action.
*/
                  case RT_DATA:
                    if(!request->lastAck)
                        request->curBlock = 1;

                    if (isInit) {
                        LOG_MSG3 (LOG_NOTICE, _("No options acknowledged"));
                        request->option.blocksize = SEGSIZE;
                    }    
/*
	success: we got the desired block
*/                        
		    if (thisBlock == hs(request->curBlock)) {
		        state = ST_PUTDATA;
                    }
/*
	previous block came in again (obviously lost ACK) or
	all others are errors, but trigger the same action: repeat last ACK
*/
                    else {
                        logSequenceError("DATA",(int)thisBlock,
                                         (int)hs(request->curBlock));
		        if (retryPossible(request,-1,NULL) == PC_ERROR)
                            return -1;
		        state = ST_ACKWAIT_AGAIN;
                    }
		}
		break;

/*
        We got the desired data packet. Put it on disk.
	Update lastAck to reflectwhat's stored so far.
*/
	    case ST_PUTDATA:
		request->xfrstat += (count_t)recvLength;
		recvLength -= sizeof(tftpH_t);
		done = (recvLength < request->option.blocksize);
		if (putXferBuffer (request->reqFd, recvBuffer->data, 
		                   recvLength, request->reqMode, done,
				   &request->iostat) != recvLength) {
		    LOG_MSG1 (LOG_ERR, _("Cannot write local data: %m"));
		    sendError(request, PE_NOSPACE, NULL);
		    return -1;
		}
		LOG_MSG6 (LOG_DEBUG,"%s: %d bytes to file %s", __FUNCTION__, 
                                    recvLength, done ? " (last block)" : "");
                request->lastAck = request->curBlock;
		state = ST_ACKWAIT;
		break;
/*
	wait for send channel to become ready
	on success, proceed with 'send'
*/
	    case ST_ACKWAIT:
	    case ST_ACKWAIT_AGAIN:
		FD_ZERO(&fdSel);
		FD_SET(request->Ssock, &fdSel);

                timeout = proBackoff(&request->times, EBS_SACK, request->retry);

                LOG_MSG6 (LOG_DEBUG, "%s: timeout %.1fs", __FUNCTION__,
                          tv2double(&timeout));

		rtc = select (hsock, NULL, &fdSel, NULL, &timeout);

                switch(checkSelError(request, rtc, BM_ACK)) {
                    case PC_ERROR:
                        return -1;
                    case PC_RETRY:
                        continue;
                }
		state = (state == ST_ACKWAIT) ? ST_ACK : ST_ACK_AGAIN;
		break;
/*
	send an ACK for the block
	in general, we should simply send and ACK for lastAck.
	But things are different if block skipping is allowed.
	In this case, we must acknowlege the desired next_block - 1
*/
	    case ST_ACK:
                if (request->bList != NULL) {
                    int nextBlock;

                    nextBlock = findNextInBlist((dlb_t *)request->bList,
                                                request->lastAck);
                    if (nextBlock != (request->lastAck+1)) {
                        LOG_MSG5 (LOG_DEBUG, "%s: skip to block: %d", 
                                  __FUNCTION__, nextBlock);
                    }
                    request->curBlock = nextBlock;
                }
                else {
                    request->curBlock++;
                }

            case ST_ACK_AGAIN:

#ifdef DEV_ADDON
                delay = getDelay(RT_ACK);
                if (delay.tv_sec) {
                    LOG_MSG5 (LOG_DEBUG, "delaying ACK by %ds for block %d", 
                              delay.tv_sec, request->curBlock-1);
                    sleep(delay.tv_sec);
                }
#endif /* DEV_ADDON */

		ackBuffer.head.opCode  = htons(RT_ACK);
		ackBuffer.head.blockNo = htons(hs(request->curBlock-1));

		rtc = sendto(request->Ssock, &ackBuffer,sizeof(ackBuffer.head),
                             0, (sa_t *)&request->reqPeer, sizeof(sai_t));

                switch(checkSendError(request, rtc, sizeof(tftpH_t), BM_ACK)) {
                    case PC_ERROR:
                        return -1;
                    case PC_RETRY:
                        state = ST_ACKWAIT;
                        continue;
                }

		LOG_MSG6 (LOG_DEBUG, "%s: ACK for block %d/%d%s",__FUNCTION__,
			  request->curBlock-1, (int)hs(request->curBlock-1), 
                          request->lastAck ? "": _(" (options)"));

		if (done)
		    return 0;

		if (state == ST_ACK)
                    request->retry = 0;

		state = ST_RECVWAIT;
		break;
	}
    }
    return -1;
}

/*
	write request (WRQ): send a file to the server

	jacket routine for CsendFile2 (the real thing, see below)
	this is done to assure an easy cleanup of dyn memory
	at function return
*/
static int CsendFile (tftpR_t *request)
{
    tftpD_t *sendBuffer;	/* send buffer (one packet)	*/
    tftpD_t *initBuffer = NULL;	/* XFER initialization buffer	*/
    int rtc, bufsize;

    request->times.start = request->times.stop = uftime(NULL);

    bufsize = MAX(request->option.blocksize, SEGSIZE) + sizeof(tftpH_t);

    if ((sendBuffer = (tftpD_t *)Malloc(bufsize)) == NULL) {
        errNoDynmem;
        request->times.stop = uftime(NULL);
        return -1;
    }

    if (initXferBuffer(request->option.blocksize)) {
        sendError(request, PE_NOSPACE, NULL);
        return -1;
    }

    rtc = CsendFile2 (request, sendBuffer, initBuffer);

    rmXferBuffer();
    request->times.stop =uftime(NULL);
    Free(sendBuffer);
    if (initBuffer != NULL)
        Free (initBuffer);
    return rtc;
}

/*
	transfer processing according to RFC 2347:

      client                                           server
      -------------------------------------------------------
      |2|barfile|0|octet|0|blksize|0|2048|0|  -->         WRQ
                             <--  |6|blksize|0|2048|0|   OACK
      |3|1| 2048 octets of data |  -->                   DATA
                                             <--  |4|1|   ACK
      |3|2| 2048 octets of data |  -->                   DATA
                                             <--  |4|2|   ACK
      |3|3|<2048 octets of data |  -->                   DATA

*/

static int CsendFile2 (tftpR_t *request,tftpD_t *sendBuffer,tftpD_t *initBuffer)
{
    tftpD_t ackBuffer;		/* acknowledge packet		*/
    int initLength;		/* length of initial packet	*/
    int recvLength;		/* received bytes		*/
    int sendLength;		/* sent bytes			*/
    int bufLength = 0;		/* lenght of transfer buffer	*/
    ushort thisAck; 		/* recent incoming ACK block	*/
    int hsock;			/* highest socket+1 (select)	*/
    int done = 0;		/* flag for end-of-transfer	*/
    int rtc;			/* general function return code	*/
    fd_set fdSel;		/* select bitmap		*/
    sai_t peer;			/* temp buffer for recvfrom     */
    socklen_t peerLength;       /* length of temp buffer        */
    struct timeval timeout;	/* timeout for select		*/
#ifdef DEV_ADDON
    struct timeval delay;	/* send/ack delay time		*/
#endif /* DEV_ADDON */
    enum io_states state;	/* state machine status		*/

    hsock = MAX(request->Rsock, request->Ssock) + 1;

/*
	Loop through the state-machine that implements the send algorithm
*/
    state = ST_INITWAIT;

    for (;;) {

        if (doTrace) {
            doTrace = 0;
            CstatusTrace (request);
        }

        LOG_MSG6 (LOG_DEBUG, "%s: state %d: %s", __FUNCTION__,
                  state,state_names[state]);

        switch (state) {

            default:
                LOG_MSG1 (LOG_ERR, _("Internal state machine error"));
                break;
/*
	wait for the output channel to becomeready to send the initial packet.
	we do not allow timeouts here.
*/
            case ST_INITWAIT:
                FD_ZERO(&fdSel);
                FD_SET(request->Ssock, &fdSel);

                timeout = proBackoff(&request->times, EBS_SEND, request->retry);

                LOG_MSG6 (LOG_DEBUG, "%s: timeout %.1fs", __FUNCTION__,
                          tv2double(&timeout));

                rtc = select (request->Ssock + 1, NULL, &fdSel, NULL, &timeout);

                switch(checkSelError(request, rtc, BM_INIT)) {
                    case PC_ERROR:
                        return -1;
                    case PC_RETRY:
                        continue;
                }
                state = ST_INIT;
                break;

/*
	assemble the initial request packet and send ist over
*/
            case ST_INIT:
                if (initBuffer == NULL)
                    initBuffer = mkInitPkt(request, NULL, &initLength);
                if (initBuffer == NULL)
                    return -1;

                startMsg (request);

                rtc = sendto(request->Ssock, initBuffer, initLength, 0,
  	                     (sa_t *)&request->reqPeer, sizeof(sai_t));

                switch(checkSendError(request, rtc, initLength, BM_INIT)) {
                    case PC_ERROR:
                        return -1;
                    case PC_RETRY:
                        state = ST_INITWAIT;
                        continue;
                }
                state = ST_ACKWAIT;
                break;
/*
	get the next chunk of data from disk
	on success fall through to 'send wait'
*/ 
            case ST_GETDATA:
                request->curBlock++;
                bufLength = getXferBuffer (request->reqFd, sendBuffer->data, 
                                           request->option.blocksize, 
                                           request->reqMode, &request->iostat);
                if (bufLength < 0) {
                    LOG_MSG1 (LOG_ERR, _("Cannot read local data: %m"));
                    return -1;
                }
                else if (bufLength < request->option.blocksize)
                    done = 1;
                sendBuffer->head.opCode  = htons(RT_DATA);
                request->retry = 0;
                LOG_MSG6 (LOG_DEBUG, "%s: %d bytes from file", __FUNCTION__, 
                          bufLength);
                state = ST_SENDWAIT;
                break;
/*
	wait for send channel to become ready
	we don't tolerate timeouts at this point
	on success, proceed with SEND
*/
            case ST_SENDWAIT:
                FD_ZERO(&fdSel);
                FD_SET(request->Ssock, &fdSel);

                timeout = proBackoff(&request->times, EBS_SEND, request->retry);

                LOG_MSG6 (LOG_DEBUG, "%s: timeout %.1fs", __FUNCTION__,
                          tv2double(&timeout));

                rtc = select (hsock, NULL, &fdSel, NULL, &timeout);

                switch(checkSelError(request, rtc, BM_DATA)) {
                    case PC_ERROR:
                        return -1;
                    case PC_RETRY:
                        continue;
                }

                state = ST_SEND;
                break;
/*
	send the current buffer
*/
            case ST_SEND:
                sendBuffer->head.blockNo = htons(hs(request->curBlock));
                sendLength = sizeof(tftpH_t) + bufLength;

#ifdef DEV_ADDON
                delay = getDelay(RT_DATA);
                if (delay.tv_sec) {
                    LOG_MSG5 (LOG_DEBUG, "delaying data by %ds for block %d",
                              delay.tv_sec, request->curBlock);
                    sleep(delay.tv_sec);
                }
#endif /* DEV_ADDON */

                rtc = sendto(request->Ssock, sendBuffer, sendLength, 0,
                             (sa_t *)&request->reqPeer, sizeof(sai_t));

                switch(checkSendError(request, rtc, sendLength, BM_DATA)) {
                    case PC_ERROR:
                        return -1;
                    case PC_RETRY:
                        state = ST_SENDWAIT;
                        continue;
                }

                LOG_MSG6 (LOG_DEBUG, "%s: block %d/%hu, size %d sent", 
                          __FUNCTION__, request->curBlock, 
                          hs(request->curBlock), sendLength); 

                request->xfrstat += (count_t)sendLength;
                state = ST_ACKWAIT;
                break;
/*
	wait for ACK from peer
	this is actually a 'wait for any reply',
	because we shoud be prepared to receive an packet,
	especially error packets.

	On timeout, we check the retry-count.
	This counter will be reset on any sucessfully transferred packet.
	If retries are still allowesd, we re-send the current packet.
*/
            case ST_ACKWAIT:
                FD_ZERO(&fdSel);
                FD_SET(request->Rsock, &fdSel);

                timeout = proBackoff(&request->times, 
                                     isInit ? EBS_CONN : EBS_SACK, 
                                     request->retry);

                LOG_MSG6 (LOG_DEBUG, "%s: timeout %.1fs", __FUNCTION__,
                          tv2double(&timeout));

                rtc = select (hsock, &fdSel, NULL, NULL, &timeout);

                switch(checkSelError(request, rtc, BM_ACK)) {
                    case PC_ERROR:
                        return -1;
                    case PC_RETRY:
                        state = isInit ? ST_INITWAIT : ST_SENDWAIT;
                        continue;
                }

                state = ST_ACK;
                break;
/*
	The received packed should be at least of length sizeof(tftpD_t)
	(usually 4 bytes). Short packets are silently discarded:
	we proceed as with timeouts above.

	Now let's check the opcode of the received packets.
	All non-ACK packets are considered fatal transfer errors, which
	lead to an abort of the current transfer.
*/
            case ST_ACK:
                peer = request->reqPeer;
                peerLength = sizeof(peer);
                recvLength = recvfrom (request->Rsock, &ackBuffer, 
                                       sizeof(tftpH_t) + SEGSIZE, 
                                       MSG_TRUNC, (sa_t *)&peer, &peerLength);

                switch(checkAckOack(request, &ackBuffer, recvLength)) {
                    case PC_ERROR:
                        return -1;
                    case PC_RETRY:
                        state = isInit ? ST_INITWAIT : ST_SENDWAIT;
                        continue;
                }
/*
	the first packet to arrive tells us the destination port
*/
                if (isInit)
                    request->reqPeer = peer;

                thisAck = ntohs(ackBuffer.head.blockNo);

                switch (ntohs(ackBuffer.head.opCode)) {

/*	
	If this is an OACK packet, following prerequisites must be met:

		- we requestd an option (request->option != 0)
		- this is an acknowlege to packet # 0
*/
                    case RT_OACK:
                        if (!isOpt) {
                            LOG_MSG1 (LOG_ERR, _("OACK without request"));
                            if (retryPossible(request, PE_BADOP,
                                "OACK without request") == PC_ERROR)
                                return -1;
                            state = ST_INITWAIT;
                            break;
                        }
                        if (thisAck) {
                            logSequenceError("ACK", (int)thisAck, 
                                             hs(request->curBlock));
                            if (retryPossible(request, PE_BADOP,
                                "OACK out of sequence") == PC_ERROR)
                                return -1;
                            state = ST_INITWAIT;
                            break;
                        }
                        if (checkOptions(ackBuffer.data,
                                         recvLength - sizeof(tftpH_t), 
                                         request)) {
                            LOG_MSG1 (LOG_ERR, _("Bad OACK options"));
                            if (retryPossible(request,-1,NULL) == PC_ERROR)
                                return -1;
                            state = ST_INITWAIT;
                            sendError(request, PE_BADOP, "Bad OACK options");
                            break;
                        }
                        state = ST_GETDATA;
                        break;
/*
	We got the desired ACK packet, so lets check the block number.
	Only 1 cases is valid: curBlock.

	If the current block was acked, proceed with the next one, or,
	if this was the last block, quit.

	If any other block was acked, either the last DATA packet was lost
	or the just received ACK packet is damaged. In any case: repeat
	the last DATA packet if the prevoius was'nt repeated.
*/
                    case RT_ACK:
                        LOG_MSG6 (LOG_DEBUG, "%s: ACK for block %hu",
                                  __FUNCTION__, thisAck);
                        if (thisAck == hs(request->curBlock)) {
                            if (done) 
                                return 0;
                            request->lastAck = request->curBlock;
                            state = ST_GETDATA;
                        }
/*
	this section deals with the protocol modification to prevent
	the ping-pong duplication following a delayed ACK
*/
                        else if ((thisAck == hs(request->lastAck)) &&
                                 !(request->times.eflag & SD_OLDPROTO)) {
                            LOG_MSG6 (LOG_DEBUG, 
                                      "%s: dup ACK: new proto - data no resent",
                                      __FUNCTION__);
                            if (retryPossible(request,PE_UNDEF,NULL)!=PC_RETRY)
                                return -1;
                            state = ST_ACKWAIT;
                        }
/*
	here if old protocol handling is explicitely selected
	and in all other cases of non matching sequence numbers
*/
                        else {
                            logSequenceError("ACK", (int)thisAck, 
                                             request->curBlock);
                            if (retryPossible(request,-1,NULL) == PC_ERROR)
                                return -1;
                            state = ST_SENDWAIT;
                        }
                }
                break;
        } 
    }
    return -1;
}


int tftp (char *server, char *port,
          char *localfile, char *serverfile, char *laddr,
          int blocksize, int sendsize, 
          char *ctimeout, char *creqtmo, int mandopt,
          int getput, int binascii, int verbose)
{
    int ios;
    static tftpR_t requestTemplate, *request = &requestTemplate;

    memset (request, 0, sizeof(tftpR_t));

    if (Ccheckargs(request, server, port, localfile, serverfile,
                   xinet_addr(laddr, 1), blocksize, 0, sendsize, 
                   ctimeout, creqtmo, mandopt,
                   getput, binascii, NULL, verbose))
        return 1;

    ios = CdoRequest(request);

    if (msgLevel) {
        if (ios)
            fprintf (stderr, _("Transmission failed\n"));
        else
            CstatusTrace (request);
    }
    return ios;
}
 
